
#include <stdlib.h>
#include <string.h>

#include "listini.h"
#include "cddest.h"
#include "listdir.h"

char SORT_DESC_FLAG;
char SECOND_DIRECTORY;

typedef int comparType(const void *, const void *);

static  comparType  *comparator;


void near exchange(int UN, int DEUX)
{
 void *tmp;
 char t;
 long l;
 char BUF[80];
 int i;

 if(!SECOND_DIRECTORY)
  {
   i = 12;
   while(i-- >= 0)
    {
      BUF[i] = REPBUF[UN][i];
      REPBUF[UN][i] = REPBUF[DEUX][i];
      REPBUF[DEUX][i] = BUF[i];
    }

   l = REPSIZE[UN]; REPSIZE[UN]=REPSIZE[DEUX];REPSIZE[DEUX] = l;
   t = D[UN]; D[UN] = D[DEUX];D[DEUX] = t;
   t = M[UN]; M[UN] = M[DEUX];M[DEUX] = t;
   t = Y[UN]; Y[UN] = Y[DEUX];Y[DEUX] = t;
   t = lockit[UN]; lockit[UN] = lockit[DEUX];lockit[DEUX] = t;
   t = filetype[UN]; filetype[UN] = filetype[DEUX];filetype[DEUX] = t;

   if (SORT_DESC_FLAG)
   {
     void *leftP = (void *)  DESCadr[UN];
     void *rightP = (void *) DESCadr[DEUX];
     tmp = leftP; leftP = rightP;  rightP = tmp;
   }
  }
 else
 {
   i = 12;
   while(i-- >= 0)
    {
      BUF[i] = DST_BUF[UN][i];
      DST_BUF[UN][i] = DST_BUF[DEUX][i];
      DST_BUF[DEUX][i] = BUF[i];
    }

   l = DST_REPSIZE[UN]; DST_REPSIZE[UN]=DST_REPSIZE[DEUX];
   DST_REPSIZE[DEUX] = l;
   t = DST_D[UN]; DST_D[UN] = DST_D[DEUX];DST_D[DEUX] = t;
   t = DST_M[UN]; DST_M[UN] = DST_M[DEUX];DST_M[DEUX] = t;
   t = DST_Y[UN]; DST_Y[UN] = DST_Y[DEUX];DST_Y[DEUX] = t;
   t = DST_lockit[UN]; DST_lockit[UN] = DST_lockit[DEUX];DST_lockit[DEUX] = t;
   t = DST_filetype[UN]; DST_filetype[UN] = DST_filetype[DEUX];DST_filetype[DEUX] = t;
  }

}




/*
void near exchange (int UN, int DEUX)
{
void *leftP;
void *rightP;

if(SECOND_DIRECTORY) goto second;

leftP = REPBUF[UN];
rightP = REPBUF[DEUX];

asm     push    ds
asm     cld
asm     mov     cx, 6
asm     les     di, rightP
asm     lds     si, leftP

asm     mov     al, es:[di]
asm     movsb                           /* swap bytes, advancing pointers */
asm     mov     [si-1], al

xch_wordLoop:
asm     mov     ax, es:[di]
asm     movsw                           /* swap words, advancing pointers */
asm     mov     [si-2], ax
asm     loop    xch_wordLoop

asm     pop     ds

asm	mov     si,word ptr [bp+4]
asm	mov	di,word ptr [bp+6]

asm	mov	al,byte ptr DGROUP:D[si]
asm	xchg	al,byte ptr DGROUP:D[di]
asm	xchg	byte ptr DGROUP:D[si],al

asm	mov	al,byte ptr DGROUP:M[si]
asm	xchg	al,byte ptr DGROUP:M[di]
asm	xchg	byte ptr DGROUP:M[si],al

asm	mov	al,byte ptr DGROUP:Y[si]
asm	xchg	al,byte ptr DGROUP:Y[di]
asm	xchg	byte ptr DGROUP:Y[si],al

asm	mov	al,byte ptr DGROUP:lockit[si]
asm	xchg	al,byte ptr DGROUP:lockit[di]
asm	xchg	byte ptr DGROUP:lockit[si],al

asm	mov	al,byte ptr DGROUP:filetype[si]
asm	xchg	al,byte ptr DGROUP:filetype[di]
asm	xchg	byte ptr DGROUP:filetype[si],al

asm	shl	si,2
asm	shl	di,2

asm	mov	dx,word ptr DGROUP:REPSIZE[si+2]
asm	mov	ax,word ptr DGROUP:REPSIZE[si]
asm	xchg	dx,word ptr DGROUP:REPSIZE[di+2]
asm	xchg	ax,word ptr DGROUP:REPSIZE[di]
asm	xchg	word ptr DGROUP:REPSIZE[si+2],dx
asm	xchg	word ptr DGROUP:REPSIZE[si],ax

asm     mov     al, SORT_DESC_FLAG
asm     test    al, al
asm     jz      skipdesc

asm	mov	dx,word ptr DGROUP:DESCadr[si+2]
asm	mov	ax,word ptr DGROUP:DESCadr[si]
asm	xchg	dx,word ptr DGROUP:DESCadr[di+2]
asm	xchg	ax,word ptr DGROUP:DESCadr[di]
asm	xchg	word ptr DGROUP:DESCadr[si+2],dx
asm	xchg	word ptr DGROUP:DESCadr[si],ax

skipdesc:
return;

second:

leftP = DST_BUF[UN];
rightP = DST_BUF[DEUX];

asm     push    ds
asm     cld
asm     mov     cx, 6
asm     les     di, rightP
asm     lds     si, leftP

asm     mov     al, es:[di]
asm     movsb                           /* swap bytes, advancing pointers */
asm     mov     [si-1], al

xch_wordLoop2:
asm     mov     ax, es:[di]
asm     movsw                           /* swap words, advancing pointers */
asm     mov     [si-2], ax
asm     loop    xch_wordLoop2

asm     pop     ds

asm	mov     si,word ptr [bp+4]
asm	mov	di,word ptr [bp+6]

asm	mov	al,byte ptr DGROUP:DST_D[si]
asm	xchg	al,byte ptr DGROUP:DST_D[di]
asm	xchg	byte ptr DGROUP:DST_D[si],al

asm	mov	al,byte ptr DGROUP:DST_M[si]
asm	xchg	al,byte ptr DGROUP:DST_M[di]
asm	xchg	byte ptr DGROUP:DST_M[si],al

asm	mov	al,byte ptr DGROUP:DST_Y[si]
asm	xchg	al,byte ptr DGROUP:DST_Y[di]
asm	xchg	byte ptr DGROUP:DST_Y[si],al

asm	mov	al,byte ptr DGROUP:DST_lockit[si]
asm	xchg	al,byte ptr DGROUP:DST_lockit[di]
asm	xchg	byte ptr DGROUP:DST_lockit[si],al

asm	mov	al,byte ptr DGROUP:DST_filetype[si]
asm	xchg	al,byte ptr DGROUP:DST_filetype[di]
asm	xchg	byte ptr DGROUP:DST_filetype[si],al

asm	shl	si,2
asm	shl	di,2

asm	mov	dx,word ptr DGROUP:DST_REPSIZE[si+2]
asm	mov	ax,word ptr DGROUP:DST_REPSIZE[si]
asm	xchg	dx,word ptr DGROUP:DST_REPSIZE[di+2]
asm	xchg	ax,word ptr DGROUP:DST_REPSIZE[di]
asm	xchg	word ptr DGROUP:DST_REPSIZE[si+2],dx
asm	xchg	word ptr DGROUP:DST_REPSIZE[si],ax
return;
}
*/

void near QuickSort (char *pivotP, size_t nElem, int P)
{
char *leftP, *rightP, *pivotEnd, *pivotTemp, *leftTemp;
unsigned  lNum;
int   retval;
unsigned int R, L, PE, LT, PT;


tailRecursion:
if (nElem <= 2)
 {
  if (nElem == 2)
   {
     R = P + 1;
     if(comparator(pivotP, rightP = 13 + pivotP) > 0)
	 exchange(P, R);
    }
  return;
  }

rightP = (nElem - 1) * 13 + pivotP;
leftP  = (nElem >> 1) * 13 + pivotP;
R = P + nElem - 1;
L = P + (nElem >> 1);

if(comparator(leftP, rightP) > 0) exchange(L, R);
if(comparator(leftP, pivotP) > 0) exchange(L, P);
else
if(comparator(pivotP, rightP) > 0) exchange(P, R);

if(nElem == 3) { exchange(P, L); return;}

leftP = pivotEnd = pivotP + 13;
PE = P + 1;
L  = PE;

    do
        {
        while ((retval = comparator(leftP, pivotP)) <= 0)
            {
            if (retval == 0)
	      {
		exchange(L, PE);
		pivotEnd += 13;
		PE++;
	      }
	    if(leftP <  rightP) { leftP += 13; L++;}
	    else goto qBreak;
            }

	while (leftP < rightP)
            {
            if ((retval = comparator(pivotP, rightP)) < 0)
	       {
		rightP -= 13;
		R--;
	       }
            else
                {
		exchange (L, R);
		if(retval != 0)
		  {
                    leftP += 13;
		    rightP -= 13;
		    L++;
		    R--;
		   }
                break;
                }
            }
	}   while (leftP < rightP);

qBreak:
    if (comparator(leftP, pivotP) <= 0)
      {
	leftP = leftP + 13;
	L++;
      }

    leftTemp = leftP - 13;
    LT = L - 1;

    pivotTemp = pivotP;
    PT = P;

    while ((pivotTemp < pivotEnd) && (leftTemp >= pivotEnd))
      {
	exchange(PT, LT);
	pivotTemp += 13;
	PT++;
	leftTemp -= 13;
	LT--;
      }

    lNum = (leftP - pivotEnd) / 13;
    nElem = ((nElem * 13 + pivotP) - leftP)/13;

    if (nElem < lNum)
      {
        QuickSort (leftP, nElem, L);
        nElem = lNum;
      }
    else
      {
        QuickSort (pivotP, lNum, P);
        pivotP = leftP;
        P = L;
      }

    goto tailRecursion;
}


void dirsort(void *baseP, size_t nElem, int startnum)
{
 comparator = (comparType *) stricmp;
 QuickSort((char *) baseP, nElem, startnum);
 SECOND_DIRECTORY = 0;
}
